package com.foreverwin.mesnac.dispatch.controller;

import com.foreverwin.modular.core.util.R;
import com.foreverwin.modular.core.util.FrontPage;
import com.foreverwin.modular.core.util.CommonMethods;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.foreverwin.mesnac.dispatch.service.SfcDispatchService;
import com.foreverwin.mesnac.dispatch.model.SfcDispatch;
import java.util.List;

/**
 *
 * @author Leon.L
 * @since 2021-06-02
 */
@RestController
@RequestMapping("/Z-SFC-DISPATCH")
public class SfcDispatchController {

    @Autowired
    public SfcDispatchService sfcDispatchService;


    @ResponseBody
    @PostMapping("querySfcDispatch")
    public R querySfcDispatch(@RequestBody SfcDispatch sfcDispatch) {
        List<SfcDispatch> list = null;
        try {

            sfcDispatch.setSite(CommonMethods.getSite());

            list = sfcDispatchService.selectList(sfcDispatch);
        } catch (Exception e) {
            return R.failed(e.getMessage());
        }

        return R.ok(list);
    }

    /**
     * 查询所有数据
     *
     * @return
     */
    @ResponseBody
    @GetMapping("")
    public R getSfcDispatchList(SfcDispatch sfcDispatch){
        List<SfcDispatch> result;
        QueryWrapper<SfcDispatch> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(sfcDispatch);
        result = sfcDispatchService.list(queryWrapper);
        return R.ok(result);
    }

    /**
     * 分页查询数据
     *
     * @param frontPage  分页信息
     * @return
     */
    @ResponseBody
    @GetMapping("/page")
    public R page(FrontPage<SfcDispatch> frontPage, SfcDispatch sfcDispatch){
        IPage result;
        QueryWrapper<SfcDispatch> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(sfcDispatch);
        if (frontPage.getGlobalQuery() != null && !"".equals(frontPage.getGlobalQuery().trim())) {
            //TODO modify global query
            queryWrapper.lambda().and(wrapper -> wrapper
                .like(SfcDispatch::getHandle, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getSite, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getShopOrder, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getWorkOrder, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getSfc, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getIsMajor, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getDispatchSeq, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getDispatchNo, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getDispatchStatus, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getDrawingsNo, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getDrawingsRevision, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getIsLock, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getRouterBo, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getStepId, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getOperation, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getResourceType, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getWorkCenter, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getResrce, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getEmployee, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getTurnOrder, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getIsAllot, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getIsImport, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getRemark, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getCreateUser, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getModifyUser, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getOther1, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getOther2, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getOther3, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getOther4, frontPage.getGlobalQuery())
                .or().like(SfcDispatch::getOther5, frontPage.getGlobalQuery())
    );
        }
        result = sfcDispatchService.page(frontPage.getPagePlus(), queryWrapper);
        return R.ok(result);
    }

    /**
     * 新增
     * @param sfcDispatch  传递的实体
     * @return  null 失败  实体成功
     */
    @PostMapping
    public R save(@RequestBody SfcDispatch sfcDispatch) {
        return R.ok(sfcDispatchService.save(sfcDispatch));
    }

    /**
     * 修改
     * @param sfcDispatch  传递的实体
     * @return  null 失败  实体成功
     */
    @PutMapping
    public R updateById(@RequestBody SfcDispatch sfcDispatch) {
        return R.ok(sfcDispatchService.updateById(sfcDispatch));
    }

    /**
     * 根据id删除对象
     * @param id  实体ID
     * @return 0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.DELETE, value = "/{id:.+}")
    public R removeById(@PathVariable("id") String id){
        return R.ok(sfcDispatchService.removeById(id));
    }

    /**
     * 批量删除对象
     * @param ids 实体集合ID
     * @return  0 失败  1 成功
     */
    @ResponseBody
    @RequestMapping(method = RequestMethod.POST, value = "/delete-batch")
    public R removeByIds(List<String> ids){
        return R.ok(sfcDispatchService.removeByIds(ids));
    }
}