package com.foreverwin.mesnac.dispatch.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;
import java.util.Date;

/**
 *
 * ClassName: shopOrderRelease
 *
 * @author Leon
 *
 * Copyright (C) 2018-2019 上海昊声电子信息技术有限公司.
 *
 * All Rights Reserved
 *
 * http://www.foreverwin.com.cn
 *
 * Create Time: 2021/06/02
 */

public class ShopOrderRelease extends SfcDispatch {

    private String locale;
    private String shopOrderBo;
    private String item;
    private String itemDescription;
    private String qtyToBuild;
    private String category;
    private String status;
    private String comments;

    private LocalDateTime plannedStartDate;
    private LocalDateTime plannedCompDate;
    private LocalDateTime dispatchCompleteDate;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date startFromDate;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date startToDate;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date completeFromDate;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd")
    private Date completeToDate;

    public String getLocale() {
        return locale;
    }

    public void setLocale(String locale) {
        this.locale = locale;
    }

    public String getShopOrderBo() {
        return shopOrderBo;
    }

    public void setShopOrderBo(String shopOrderBo) {
        this.shopOrderBo = shopOrderBo;
    }

    public String getItem() {
        return item;
    }

    public void setItem(String item) {
        this.item = item;
    }

    public String getItemDescription() {
        return itemDescription;
    }

    public void setItemDescription(String itemDescription) {
        this.itemDescription = itemDescription;
    }

    public String getQtyToBuild() {
        return qtyToBuild;
    }

    public void setQtyToBuild(String qtyToBuild) {
        this.qtyToBuild = qtyToBuild;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getComments() {
        return comments;
    }

    public void setComments(String comments) {
        this.comments = comments;
    }

    @Override
    public LocalDateTime getPlannedStartDate() {
        return plannedStartDate;
    }

    @Override
    public void setPlannedStartDate(LocalDateTime plannedStartDate) {
        this.plannedStartDate = plannedStartDate;
    }

    public LocalDateTime getPlannedCompDate() {
        return plannedCompDate;
    }

    public void setPlannedCompDate(LocalDateTime plannedCompDate) {
        this.plannedCompDate = plannedCompDate;
    }

    public LocalDateTime getDispatchCompleteDate() {
        return dispatchCompleteDate;
    }

    public void setDispatchCompleteDate(LocalDateTime dispatchCompleteDate) {
        this.dispatchCompleteDate = dispatchCompleteDate;
    }

    public Date getStartFromDate() {
        return startFromDate;
    }

    public void setStartFromDate(Date startFromDate) {
        this.startFromDate = startFromDate;
    }

    public Date getStartToDate() {
        return startToDate;
    }

    public void setStartToDate(Date startToDate) {
        this.startToDate = startToDate;
    }

    public Date getCompleteFromDate() {
        return completeFromDate;
    }

    public void setCompleteFromDate(Date completeFromDate) {
        this.completeFromDate = completeFromDate;
    }

    public Date getCompleteToDate() {
        return completeToDate;
    }

    public void setCompleteToDate(Date completeToDate) {
        this.completeToDate = completeToDate;
    }
}
