package com.foreverwin.mesnac.dispatch.service.impl;

import com.foreverwin.modular.core.util.FrontPage;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.foreverwin.mesnac.dispatch.model.SfcDispatch;
import com.foreverwin.mesnac.dispatch.mapper.SfcDispatchMapper;
import com.foreverwin.mesnac.dispatch.service.SfcDispatchService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author Leon.L
 * @since 2021-06-02
 */
@Service
@Transactional(rollbackFor = Exception.class)
public class SfcDispatchServiceImpl extends ServiceImpl<SfcDispatchMapper, SfcDispatch> implements SfcDispatchService {


    @Autowired
    private SfcDispatchMapper sfcDispatchMapper;

    @Override
    public IPage<SfcDispatch> selectPage(FrontPage<SfcDispatch> frontPage, SfcDispatch sfcDispatch) {
        QueryWrapper<SfcDispatch> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(sfcDispatch);
        return super.page(frontPage.getPagePlus(), queryWrapper);
    }

    @Override
    public List<SfcDispatch> selectList(SfcDispatch sfcDispatch) {
        QueryWrapper<SfcDispatch> queryWrapper = new QueryWrapper<>();
        queryWrapper.setEntity(sfcDispatch);
        return super.list(queryWrapper);
    }

    @Override
    public List<SfcDispatch> findSfcDispatch(String site, String sfc, String operation, String stepId) {
        return sfcDispatchMapper.findSfcDispatch(site, sfc, operation, stepId);
    }


}